#include<iostream>
#include<vector>
using namespace std;
int main()
{
    int resenje=0;
    long long  n,k,velicina;
    cin >> n >> k;
    long M[n][n];
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            cin >>M[i][j];
        }
    }
    vector<int> a;
    int dodati,tt=0;
    long M1[n][n];
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            M1[i][j]=0;
        }
    }
    vector<int>::iterator t1=a.begin();
    vector<int>::iterator t2=a.end();
    vector<int>::iterator t;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            dodati=M[i][j];
            for(t=t1;t<t2;t++)
            {
                if(dodati==*t)
                    tt=1;
            }
            if(tt==0)
            {
                a.push_back(dodati);
                t1=a.begin();
                t2=a.end();
            }
        tt=0;
        }
    }
    int br1=0,br2=0,b1=0,b2=0,tacno=0;
    int vazi1=0,vazi=0,vazi3=0;
    velicina = a.size();
    for(int rez=0;rez<velicina;rez++)
    {

        for(int i=0;i<n;i++)
        {
            if(vazi3==1)
                break;
            for(int j=0;j<n;j++)
            {
                if(vazi3==1)
                    break;
                if(M[i][j]==a[rez])
                {
                    vazi3=1;
                    b1=i;b2=j;
                    while(M[b1][j]==a[rez])
                        b1++;
                    while(M[i][b2]==a[rez])
                        b2++;
                    b1--;b2--;
                    for(int i1=i;i1<=b1;i1++)
                    {
                        for(int j1=j;j1<=b2;j1++)
                        {
                            M1[i1][j1]=1;
                            if(M[i1][j1]!=a[rez])
                            {
                                vazi=1;
                            }
                        }
                    }
                }

                }
            }

        if(vazi!=1)
        {
            for(int i=0;i<n;i++)
            {
                for(int j=0;j<n;j++)
                {
                    if(M1[i][j]!=1 && M[i][j]==a[rez])
                    {
                        vazi1=1;
                    }
                }
            }

        }
        if(vazi1==0)
            resenje++;
        vazi1=0;vazi=0,vazi3=0;
        for(int i=0;i<n;i++)
        {
             for(int j=0;j<n;j++)
             {
                   M1[i][j]=0;
             }
        }
    }
    cout << resenje;

    }